package pw.yumc.MenuProtect.listen;

import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.event.inventory.InventoryMoveItemEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;

import pw.yumc.MenuProtect.utils.MarkUtil;
import pw.yumc.YumCore.kit.PKit;

public class ProtectListener implements Listener {

    @EventHandler(priority = EventPriority.MONITOR)
    public void onInvClick(final InventoryClickEvent e) {
        if (e.getWhoClicked() instanceof Player) {
            handlerPlayerClick((Player) e.getWhoClicked(), e.getCurrentItem());
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onInvClose(final InventoryCloseEvent e) {
        if (e.getPlayer() instanceof Player) {
            handlerPlayerInventory((Player) e.getPlayer());
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onInvMove(final InventoryMoveItemEvent e) {
        final ItemStack ci = e.getItem();
        if (MarkUtil.clearMark(ci) != null) {
            e.setCancelled(true);
        }
    }

    private ItemStack[] handlerItems(final ItemStack[] cis) {
        for (int i = 0; i < cis.length; i++) {
            final ItemStack itemStack = cis[i];
            if (MarkUtil.clearMark(itemStack) != null) {
                cis[i] = new ItemStack(Material.AIR);
            }
        }
        return cis;
    }

    private void handlerPlayerClick(final Player p, final ItemStack is) {
        PKit.runTaskAsync(new Runnable() {
            @Override
            public void run() {
                MarkUtil.handlerItemClick(p, is);
            }
        });
    }

    private void handlerPlayerInventory(final Player p) {
        PKit.runTaskAsync(new Runnable() {
            @Override
            public void run() {
                final PlayerInventory inv = p.getInventory();
                inv.setArmorContents(handlerItems(inv.getArmorContents()));
                inv.setContents(handlerItems(inv.getContents()));
            }
        });
    }
}
