package pw.yumc.MenuProtect.utils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import pw.yumc.YumCore.bukkit.Log;
import pw.yumc.YumCore.kit.PKit;

public class MarkUtil {
    public static List<String> marks = null;
    public static Map<String, List<String>> cmds = new HashMap<>();

    public static void handlerItemClick(final Player p, final ItemStack is) {
        String leftName = clearMark(is);
        if (leftName != null) {
            String key = null;
            ItemMeta im = is.getItemMeta();
            if (cmds.containsKey(leftName)) {
                key = leftName;
            } else if (im.hasLore()) {
                for (final String lore : is.getItemMeta().getLore()) {
                    if (cmds.containsKey(lore)) {
                        key = lore;
                    }
                }
            }
            if (key != null) {
                for (final String cmd : cmds.get(key)) {
                    PKit.runTask(new Runnable() {
                        @Override
                        public void run() {
                            CommandSender sender = Bukkit.getConsoleSender();
                            if (cmd.startsWith("[p]")) {
                                sender = p;
                            }
                            final String rcmd = cmd.replaceAll("%player%", p.getName());
                            Bukkit.dispatchCommand(sender, rcmd.startsWith("[") ? rcmd.substring(3) : rcmd);
                        }
                    });
                }
            }
        }
    }

    public static String clearMark(final ItemStack ci) {
        try {
            for (final String mark : marks) {
                if (ci.getItemMeta().getDisplayName().startsWith(mark)) { return ci.getItemMeta().getDisplayName().split(mark)[1]; }
            }
        } catch (final Exception ignored) {
        }
        return null;
    }

    public static void initCommand(final ConfigurationSection cfg) {
        cmds.clear();
        for (final String lore : cfg.getKeys(false)) {
            cmds.put(lore, cfg.getStringList(lore));
        }
        Log.info("初始化LoreCommand完毕 总计: " + cmds.size() + "条...");
    }
}
